#include <math.h>
#include <VRS51L3074_SDCC.h>

#include "goku.h"
#include "cika.h"
#include "powertip.h"
#include "ramtron.h"
#include "ramtronb.h"
#include "pdm.h"
#include "lowlevel.h"
#include "highlevel.h"

//;-------------------------------------------------------------------
//;- DELAY1MSTO : 1MS DELAY USING TIMER0
//; CALIBRATED FOR 40MHZ
//;-------------------------------------------------------------------
void delay(unsigned int dlais){
idata unsigned char x=0;
idata unsigned int dlaisloop;
x = PERIPHEN1; //LOAD PERIPHEN1 REG
x |= 0x01; //ENABLE TIMER 0
PERIPHEN1 = x;
dlaisloop = dlais;
while ( dlaisloop > 0)
{
TH0 = 0x63; //TIMER0 RELOAD VALUE FOR 1MS AT 40MHZ
TL0 = 0xC0;
T0T1CLKCFG = 0x00; //NO PRESCALER FOR TIMER 0 CLOCK
T0CON = 0x04; //START TIMER 0, COUNT UP
do{
x=T0CON;
x= x & 0x80;
}while(x==0);
T0CON = 0x00; //Stop Timer 0
dlaisloop = dlaisloop-1;
}//end of while dlais...
x = PERIPHEN1; //LOAD PERIPHEN1 REG
x = x & 0xFE; //DISABLEBLE TIMER 0
PERIPHEN1 = x;
}//End of function delais

#define MsDelay(a) delay(a)

main()
{
extern __code unsigned char cika[],goku[],ramtron[],ramtronb[],powertip[],pdm[];
unsigned int i,addr;
__xdata int dy,py,ny;
__xdata unsigned int yl, yh;

	LCD_init();
	while(1){

		LCD_cleartxt();
		LCD_cleargfx();
		MsDelay ( 1000 );						// wait 1 sec
								// address gfx screen
		LCD_fill(1200,40,240,0xFF);					// black fill
		MsDelay ( 3000 );						// wait 3 secs
		LCD_cleargfx();
		LCD_icon(1200+40*99,40,42,ramtronb);
		MsDelay (3000);						// wait 3 secs
		LCD_cleargfx();
		LCD_line(0,120,319,120);
		LCD_line(160,0,160,239);
		LCD_icon(1200+40*50,152/8,20,ramtron);
		LCD_icon(1200+21+40*42,152/8,35,powertip);
		LCD_icon(1200+40*150,152/8,61,pdm);
		LCD_icon(1200+21+40*170,152/8,20,ramtron);
		LCD_rectangle(0,0,319,239);
		MsDelay ( 6000 );						// wait 3 secs
		LCD_cleargfx();
		LCD_dump(goku);						// show gfx
		LCD_printat(0,0,"Texto y graficos");
		LCD_printat(1,2,"superpuestos");
		LCD_fill(1200+8*40+2,12,8,0xFF);				// invert
		MsDelay ( 5000 );						// wait 3 secs
		LCD_cleargfx();
		LCD_printat(12,9,"Cika Electronica S.R.L.");
		LCD_printat(15,9,"Master distribuidor de");
		LCD_printat(18,8,"componentes electronicos");
		yl =  0;
		yh = 185;
		ny = 100;
   		dy = 1;
		i=500;
		py=ny;

		while(i--){
		    addr=1200+(py<<5)+(py<<3);                       // 1200 + py*40
		    LCD_fill(addr,40,54,0);
	   	    py = ny;
		    addr=1200+(py<<5)+(py<<3);                       // 1200 + py*40
		    LCD_icon(addr,40,54,cika);
		    MsDelay(50);
 	   	    ny = py + dy;
		    if (ny < yl || ny > yh) {
   	      		dy = -dy;
			ny = py + dy;
		    }
		}
		LCD_cleargfx();
		LCD_icon(1200+40*197,40,42,ramtronb);
		yh = 143;
		i=500;
		py=ny;

		while(i--){
		    addr=1200+(py<<5)+(py<<3);                       // 1200 + py*40
		    LCD_fill(addr,40,54,0);
	   	    py = ny;
		    addr=1200+(py<<5)+(py<<3);                       // 1200 + py*40
		    LCD_icon(addr,40,54,cika);
		    MsDelay(50);
 	   	    ny = py + dy;
		    if (ny < yl || ny > yh) {
   	      		dy = -dy;
			ny = py + dy;
		    }
		}
	}
}
